type ('a2, 'a1) _state_470 = {mutable _469:'a2; mutable _init416:'a1;}
and ('a4, 'a3, 'a2, 'a1)
      _state_488 = {mutable _487:'a4;
                    mutable _486:'a3;
                    mutable _init422:'a2; mutable _pre421:'a1;}
and ('a3, 'a2, 'a1)
      _state_508 = {mutable _507:'a3;
                    mutable _init428:'a2; mutable _pre427:'a1;}
and ('a2, 'a1) _state_462 = {mutable _461:'a2; mutable _init413:'a1;}
and ('a6, 'a5, 'a4, 'a3, 'a2, 'a1)
      _state_500 = {mutable _499:'a6;
                    mutable _498:'a5;
                    mutable _497:'a4;
                    mutable _496:'a3; mutable _495:'a2; mutable _init424:'a1;}
and ('a4, 'a3, 'a2, 'a1)
      _state_479 = {mutable _478:'a4;
                    mutable _477:'a3;
                    mutable _init419:'a2; mutable _pre418:'a1;}

let dt = 0.01

let l = 15.

let g = 10.

let b = 1.5

let m = 5.

let integr _cl19 _22__dx _405 _self_460 =
      let _self_460 = match !_self_460 with | `St_464(_self_460) -> _self_460
                        | _ ->
                            (let _463 = {_461 = ref `Snil_; _init413 = true} in
                             _self_460 := `St_464(_463); _463)
                         in
      let _412 = ref false in
      let _cl429__ = ref false in
      let _411 = ref 0. in
      (if _cl19 then
        (_412 := (or) _405 _self_460._init413;
         _cl429__ := true;
         _411 := Misc.integr !_cl429__ dt _22__dx !_412 _self_460._461));
      _self_460._init413 <- (&) !_412 (not _cl19); !_411

let deriv _cl31 _34__x _406 _self_468 =
      let _self_468 = match !_self_468 with | `St_472(_self_468) -> _self_468
                        | _ ->
                            (let _471 = {_469 = ref `Snil_; _init416 = true} in
                             _self_468 := `St_472(_471); _471)
                         in
      let _415 = ref false in
      let _414 = ref 0. in
      let _cl430__ = ref false in
      (if _cl31 then
        (_415 := (or) _406 _self_468._init416;
         _cl430__ := true;
         _414 := Misc.deriv !_cl430__ dt _34__x !_415 _self_468._469));
      _self_468._init416 <- (&) !_415 (not _cl31); !_414

let pendulum _cl136 _137__theta0 _138__d2x0 _139__d2y0 _407 _self_476 =
      let _self_476 = match !_self_476 with | `St_481(_self_476) -> _self_476
                        | _ ->
                            (let _480 = {_478 = ref `Snil_;
                                         _477 = ref `Snil_;
                                         _init419 = true; _pre418 = 0.} in
                             _self_476 := `St_481(_480); _480)
                         in
      let _417 = ref false in
      let _cl432__ = ref false in
      let _cl431__ = ref false in
      let _141__thetap = ref 0. in
      let _140__theta = ref 0. in
      (if _cl136 then
        (_417 := (or) _407 _self_476._init419;
         _141__thetap := (if !_417 then _137__theta0 else _self_476._pre418);
         _cl431__ := true;
         _cl432__ := true;
         _140__theta :=
           integr
             !_cl431__
             ((/.)
               (integr
                 !_cl432__
                 ((-.)
                   (( *. )
                     (sin !_141__thetap) ((+.) _139__d2y0 (( *. ) g m)))
                   (( *. ) (cos !_141__thetap) _138__d2x0))
                 !_417 _self_476._477)
               l)
             !_417 _self_476._478));
      _self_476._init419 <- (&) !_417 (not _cl136);
      (if _cl136 then _self_476._pre418 <- !_140__theta); !_140__theta

let pendulum _cl262 _263__theta0 _264__d2x0 _265__d2y0 _408 _self_485 =
      let _self_485 = match !_self_485 with | `St_490(_self_485) -> _self_485
                        | _ ->
                            (let _489 = {_487 = ref `Snil_;
                                         _486 = ref `Snil_;
                                         _init422 = true; _pre421 = 0.} in
                             _self_485 := `St_490(_489); _489)
                         in
      let _267__thetap = ref 0. in
      let _420 = ref false in
      let _266__theta = ref 0. in
      let _cl434__ = ref false in
      let _cl433__ = ref false in
      (if _cl262 then
        (_420 := (or) _408 _self_485._init422;
         _267__thetap := (if !_420 then _263__theta0 else _self_485._pre421);
         _cl433__ := true;
         _cl434__ := true;
         _266__theta :=
           integr
             !_cl433__
             ((-.)
               ((/.)
                 (integr
                   !_cl434__
                   ((-.)
                     (( *. )
                       (sin !_267__thetap) ((+.) _265__d2y0 (( *. ) g m)))
                     (( *. ) (cos !_267__thetap) _264__d2x0))
                   !_420 _self_485._486)
                 l)
               (( *. ) b !_267__thetap))
             !_420 _self_485._487));
      _self_485._init422 <- (&) !_420 (not _cl262);
      (if _cl262 then _self_485._pre421 <- !_266__theta); !_266__theta

let mpendulum _cl336 _340__theta0 _341__x0 _342__y0 _409 _self_494 =
      let _self_494 = match !_self_494 with | `St_502(_self_494) -> _self_494
                        | _ ->
                            (let _501 = {_499 = ref `Snil_;
                                         _498 = ref `Snil_;
                                         _497 = ref `Snil_;
                                         _496 = ref `Snil_;
                                         _495 = ref `Snil_; _init424 = true} in
                             _self_494 := `St_502(_501); _501)
                         in
      let _423 = ref false in
      let _cl439__ = ref false in
      let _cl438__ = ref false in
      let _cl437__ = ref false in
      let _cl436__ = ref false in
      let _cl435__ = ref false in
      let _347__y = ref 0. in
      let _346__x = ref 0. in
      let _345__theta = ref 0. in
      let _344__d2y0 = ref 0. in
      let _343__d2x0 = ref 0. in
      (if _cl336 then
        (_423 := (or) _409 _self_494._init424;
         _cl435__ := true;
         _cl436__ := true;
         _343__d2x0 :=
           deriv
             !_cl435__
             (deriv !_cl436__ _341__x0 !_423 _self_494._495)
             !_423 _self_494._496;
         _cl437__ := true;
         _cl438__ := true;
         _344__d2y0 :=
           deriv
             !_cl437__
             (deriv !_cl438__ _342__y0 !_423 _self_494._497)
             !_423 _self_494._498;
         _cl439__ := true;
         _345__theta :=
           pendulum
             !_cl439__
             _340__theta0 !_343__d2x0 !_344__d2y0 !_423 _self_494._499;
         _346__x := (+.) _341__x0 (( *. ) l (sin !_345__theta));
         _347__y := (+.) _342__y0 (( *. ) l (cos !_345__theta))));
      _self_494._init424 <- (&) !_423 (not _cl336);
      (_341__x0, _342__y0, !_346__x, !_347__y, !_345__theta)

let manual _cl397 _cl375 () _410 _self_506 =
      let _self_506 = match !_self_506 with | `St_510(_self_506) -> _self_506
                        | _ ->
                            (let _509 = {_507 = ref `Snil_;
                                         _init428 = true;
                                         _pre427 = Obj.magic ()} in
                             _self_506 := `St_510(_509); _509)
                         in
      let _cl441__ = ref false in
      let _cl440__ = ref false in
      let _404__p = ref (Obj.magic ()) in
      let _cl446__ = ref false in
      let _cl445__ = ref false in
      let _444 = ref (0., 0., 0., 0., 0.) in
      let _426 = ref false in
      let _cl443__ = ref false in
      let _425 = ref () in
      let _442 = ref (0., 0.) in
      (if _cl397 then
        (_cl440__ := true; _442 := Data.get_cursor !_cl440__ !_cl441__ ()));
      (let (_398__x0, _399__y0) = !_442 in
       (if _cl397 then
         (_426 := (or) _410 _self_506._init428;
          _cl443__ := true;
          _444 :=
            mpendulum !_cl443__ 0. _398__x0 _399__y0 !_426 _self_506._507));
       (let (_400__x0, _401__y0, _402__x, _403__y, _) = !_444 in
        (if _cl397 then
          (_cl445__ := true;
           _404__p :=
             Data.make_pend !_cl445__ _400__x0 _401__y0 _402__x _403__y;
           _cl446__ := true;
           _425 :=
             Data.draw_pendulum
               !_cl446__
               !_404__p (if !_426 then !_404__p else _self_506._pre427)));
        _self_506._init428 <- (&) !_426 (not _cl397);
        (if _cl397 then _self_506._pre427 <- !_404__p); !_425))