type state__970 =  | State__969Off | State__969On
and state__977 =  | State__976Regulation | State__976Interrupt
and ('a3, 'a2, 'a1)
      _state_1151 = {mutable _1150:'a3;
                     mutable _init1087:'a2; mutable _pre1086:'a1;}
and ('a2, 'a1) _state_1120 = {mutable _init1077:'a2; mutable _pre1076:'a1;}
and ('a2, 'a1) _state_1127 = {mutable _init1080:'a2; mutable _pre1079:'a1;}
and ('a9, 'a8, 'a7, 'a6, 'a5, 'a4, 'a3, 'a2, 'a1)
      _state_1168 = {mutable _1167:'a9;
                     mutable _1166:'a8;
                     mutable _1165:'a7;
                     mutable _1164:'a6;
                     mutable _1163:'a5;
                     mutable _1162:'a4;
                     mutable _init1093:'a3;
                     mutable _pre1092:'a2; mutable _pre1091:'a1;}
and ('a2, 'a1) _state_1143 = {mutable _init1084:'a2; mutable _pre993:'a1;}
and button =  | Down | Up
and state__984 =  | State__983RegulOn | State__983StandBy
and ('a13, 'a12, 'a11, 'a10, 'a9, 'a8, 'a7, 'a6, 'a5, 'a4, 'a3, 'a2, 'a1)
      _state_1136 = {mutable _1135:'a13;
                     mutable _1134:'a12;
                     mutable _init1015:'a11;
                     mutable _pre988:'a10;
                     mutable _pre986:'a9;
                     mutable _pre981:'a8;
                     mutable _pre979:'a7;
                     mutable _init1011:'a6;
                     mutable _init998:'a5;
                     mutable _init1082:'a4;
                     mutable _pre991:'a3;
                     mutable _pre974:'a2; mutable _pre972:'a1;}

let speedInc = 5.

let speedMax = 150.

let speedMin = 30.

let kp = 10.

let ki = 0.2

let cruiseSpeedMgt
    _cl168
    (_171__onn, _172__set, _173__quickAccel, _174__quickDecel, _175__speed)
    _994 _self_1119 =
      let _self_1119 = match !_self_1119 with
                         | `St_1122(_self_1119) -> _self_1119
                         | _ ->
                             (let _1121 = {_init1077 = true; _pre1076 = 0.} in
                              _self_1119 := `St_1122(_1121); _1121)
                          in
      let _179__l3 = ref 0. in
      let _178__cruise_speed = ref 0. in
      let _177__l2 = ref 0. in
      let _176__l1 = ref 0. in
      let _1075 = ref false in
      (if _cl168 then
        (_1075 := (or) _994 _self_1119._init1077;
         _179__l3 := (if !_1075 then 0. else _self_1119._pre1076);
         _176__l1 := (+.) !_179__l3 speedInc;
         _177__l2 := (-.) !_179__l3 speedInc;
         _178__cruise_speed :=
           (if (&) _174__quickDecel ((>=) !_177__l2 speedMin) then !_177__l2
             else
             (if (&) _173__quickAccel ((<=) !_176__l1 speedMax) then
               !_176__l1 else
               (if
                 (&)
                   ((&)
                     ((or) _171__onn _172__set) ((<=) _175__speed speedMax))
                   ((>=) _175__speed speedMin)
                 then _175__speed else !_179__l3)))));
      _self_1119._init1077 <- (&) !_1075 (not _cl168);
      (if _cl168 then _self_1119._pre1076 <- !_178__cruise_speed);
      !_178__cruise_speed

let regulator _cl253 (_256__cruise_speed, _257__speed) _995 _self_1126 =
      let _self_1126 = match !_self_1126 with
                         | `St_1129(_self_1126) -> _self_1126
                         | _ ->
                             (let _1128 = {_init1080 = true; _pre1079 = 0.} in
                              _self_1126 := `St_1129(_1128); _1128)
                          in
      let _1078 = ref false in
      let _260__aux = ref 0. in
      let _259__throttle = ref 0. in
      let _258__delta = ref 0. in
      (if _cl253 then
        (_258__delta := (-.) _256__cruise_speed _257__speed;
         _1078 := (or) _995 _self_1126._init1080;
         _260__aux :=
           (+.) !_258__delta (if !_1078 then 0. else _self_1126._pre1079);
         _259__throttle :=
           (+.) (( *. ) !_258__delta kp) (( *. ) !_260__aux ki)));
      _self_1126._init1080 <- (&) !_1078 (not _cl253);
      (if _cl253 then _self_1126._pre1079 <- !_260__aux); !_259__throttle

let cruiseControl
    _cl382
    (_399__onn,
     _400__off,
     _401__resume,
     _402__speed,
     _403__set, _404__quickAccel, _405__quickDecel, _406__accel, _407__brake)
    _996 _self_1133 =
      let _self_1133 = match !_self_1133 with
                         | `St_1138(_self_1133) -> _self_1133
                         | _ ->
                             (let _1137 = {_1135 = ref `Snil_;
                                           _1134 = ref `Snil_;
                                           _init1015 = true;
                                           _pre988 = false;
                                           _pre986 = State__983RegulOn;
                                           _pre981 = false;
                                           _pre979 = State__976Regulation;
                                           _init1011 = true;
                                           _init998 = true;
                                           _init1082 = true;
                                           _pre991 = 0.;
                                           _pre974 = false;
                                           _pre972 = State__969Off} in
                              _self_1133 := `St_1138(_1137); _1137)
                          in
      let _cl1095__ = ref false in
      let _985 = ref State__983RegulOn in
      let _cl1094__ = ref false in
      let _978 = ref State__976Regulation in
      let _1081 = ref false in
      let __last990 = ref 0. in
      let _411__cruiseSpeed = ref 0. in
      let _971 = ref State__969Off in
      let _410__throttleCmd = ref 0. in
      let _409__accelerator = ref false in
      let _408__braking = ref false in
      (if _cl382 then
        (_408__braking := (>) _407__brake 0.;
         _409__accelerator := (>) _406__accel 0.;
         _1081 := (or) _996 _self_1133._init1082;
         __last990 := (if !_1081 then 0. else _self_1133._pre991);
         _971 := (if !_1081 then State__969Off else _self_1133._pre972);
         (match !_971 with
           | State__969Off ->
               (_411__cruiseSpeed := !__last990;
                _410__throttleCmd := _406__accel;
                (match _399__onn with
                  | true ->
                      (_self_1133._pre974 <- true;
                       _self_1133._pre972 <- State__969On)
                  | _ ->
                      (_self_1133._pre974 <- false;
                       _self_1133._pre972 <- !_971)
                  );
                _self_1133._init998 <- (or) _996 _self_1133._init998)
           | State__969On ->
               (let _1005 = (or) _996 _self_1133._init998 in
                let _1006 = (or) _self_1133._pre974 _1005 in
                (match _400__off with
                  | true ->
                      (_self_1133._pre974 <- true;
                       _self_1133._pre972 <- State__969Off)
                  | _ ->
                      (_self_1133._pre974 <- false;
                       _self_1133._pre972 <- !_971)
                  );
                _978 :=
                  (if _1006 then State__976Regulation else
                    _self_1133._pre979);
                (match !_978 with
                  | State__976Regulation ->
                      (let _412__between = (&)
                                             ((>=) _402__speed speedMin)
                                             ((<=) _402__speed speedMax) in
                       let _1013 = (or) _1006 _self_1133._init1011 in
                       let _1014 = (or) _self_1133._pre981 _1013 in
                       (if _cl382 then
                         (if (&&) true true then
                           (if (&&) true true then _cl1094__ := true)));
                       (let _413__cruise_speed = cruiseSpeedMgt
                                                   !_cl1094__
                                                   (_399__onn,
                                                    _403__set,
                                                    _404__quickAccel,
                                                    _405__quickDecel,
                                                    _402__speed)
                                                   _1014 _self_1133._1134 in
                        _411__cruiseSpeed := _413__cruise_speed;
                        _985 :=
                          (if _1014 then State__983RegulOn else
                            _self_1133._pre986);
                        (match !_985 with
                          | State__983RegulOn ->
                              (let _1017 = (or) _1014 _self_1133._init1015 in
                               let _1018 = (or) _self_1133._pre988 _1017 in
                               (if _cl382 then
                                 (if (&&) true true then
                                   (if (&&) true true then
                                     (if (&&) true true then
                                       _cl1095__ := true))));
                               _410__throttleCmd :=
                                 regulator
                                   !_cl1095__
                                   (_413__cruise_speed, _402__speed)
                                   _1018 _self_1133._1135;
                               (match (or)
                                        !_409__accelerator
                                        (not _412__between) with
                                 | true ->
                                     (_self_1133._pre988 <- true;
                                      _self_1133._pre986 <- State__983StandBy)
                                 | _ ->
                                     (_self_1133._pre988 <- false;
                                      _self_1133._pre986 <- !_985)
                                 );
                               _self_1133._init1015 <- false)
                          | State__983StandBy ->
                              (_410__throttleCmd := _406__accel;
                               (match (&)
                                        (not !_409__accelerator)
                                        _412__between with
                                 | true ->
                                     (_self_1133._pre988 <- true;
                                      _self_1133._pre986 <- State__983RegulOn)
                                 | _ ->
                                     (_self_1133._pre988 <- false;
                                      _self_1133._pre986 <- !_985)
                                 );
                               _self_1133._init1015 <-
                                 (or) _1014 _self_1133._init1015)
                          );
                        (match !_408__braking with
                          | true ->
                              (_self_1133._pre981 <- true;
                               _self_1133._pre979 <- State__976Interrupt)
                          | _ ->
                              (_self_1133._pre981 <- false;
                               _self_1133._pre979 <- !_978)
                          );
                        _self_1133._init1011 <- false))
                  | State__976Interrupt ->
                      (_411__cruiseSpeed := !__last990;
                       _410__throttleCmd := _406__accel;
                       (match _401__resume with
                         | true ->
                             (_self_1133._pre981 <- true;
                              _self_1133._pre979 <- State__976Regulation)
                         | _ ->
                             (_self_1133._pre981 <- false;
                              _self_1133._pre979 <- !_978)
                         );
                       _self_1133._init1011 <-
                         (or) _1006 _self_1133._init1011)
                  );
                _self_1133._init998 <- false)
           )));
      _self_1133._init1082 <- (&) !_1081 (not _cl382);
      (if _cl382 then _self_1133._pre991 <- !_411__cruiseSpeed);
      (!_411__cruiseSpeed, !_410__throttleCmd)

let button _cl453 _471__init _472__step _473__key _1039 _self_1142 =
      let _self_1142 = match !_self_1142 with
                         | `St_1145(_self_1142) -> _self_1142
                         | _ ->
                             (let _1144 = {_init1084 = true; _pre993 = 0.} in
                              _self_1142 := `St_1145(_1144); _1144)
                          in
      let _474__o = ref 0. in
      let _1083 = ref false in
      let __last992 = ref 0. in
      (if _cl453 then
        (_1083 := (or) _1039 _self_1142._init1084;
         __last992 := (if !_1083 then _471__init else _self_1142._pre993);
         (match _473__key with
           | (_475__v, true) ->
               (match _475__v with
                 | Up -> _474__o := (+.) !__last992 _472__step
                 | Down -> _474__o := (-.) !__last992 _472__step )
           | _ -> _474__o := !__last992 )));
      _self_1142._init1084 <- (&) !_1083 (not _cl453);
      (if _cl453 then _self_1142._pre993 <- !_474__o); !_474__o

let interface _cl672 _677__key _1048 _self_1149 =
      let _self_1149 = match !_self_1149 with
                         | `St_1153(_self_1149) -> _self_1149
                         | _ ->
                             (let _1152 = {_1150 = ref `Snil_;
                                           _init1087 = true; _pre1086 = 0.} in
                              _self_1149 := `St_1153(_1152); _1152)
                          in
      let _679__speed = ref (Obj.magic (), false) in
      let _678__brake = ref ((), false) in
      let _695__brake = ref 0. in
      let _694__accel = ref 0. in
      let _1085 = ref false in
      let _693__speed = ref 0. in
      let _692__quickDecel = ref false in
      let _691__quickAccel = ref false in
      let _690__resume = ref false in
      let _689__set = ref false in
      let _688__off = ref false in
      let _cl1096__ = ref false in
      let _687__onn = ref false in
      let _685__onn = ref ((), false) in
      let _684__off = ref ((), false) in
      let _683__set = ref ((), false) in
      let _682__resume = ref ((), false) in
      let _681__quickAccel = ref ((), false) in
      let _680__quickDecel = ref ((), false) in
      (if _cl672 then
        ((match _677__key with | Data.None -> ()
           | Data.Some(_686__v) ->
               (match _686__v with | 'o' -> _685__onn := ((), true)
                 | 'f' -> _684__off := ((), true)
                 | 's' -> _683__set := ((), true)
                 | 'r' -> _682__resume := ((), true)
                 | 'a' -> _681__quickAccel := ((), true)
                 | 'd' -> _680__quickDecel := ((), true)
                 | '+' -> _679__speed := (Up, true)
                 | '-' -> _679__speed := (Down, true)
                 | 'b' -> _678__brake := ((), true) | _ -> () )
           );
         _687__onn := snd !_685__onn;
         _688__off := snd !_684__off;
         _689__set := snd !_683__set;
         _690__resume := snd !_682__resume;
         _691__quickAccel := snd !_681__quickAccel;
         _692__quickDecel := snd !_680__quickDecel;
         _1085 := (or) _1048 _self_1149._init1087;
         _cl1096__ := true;
         _693__speed :=
           button !_cl1096__ 0. 2. !_679__speed !_1085 _self_1149._1150;
         _694__accel :=
           (if !_1085 then 0. else (-.) !_693__speed _self_1149._pre1086);
         _695__brake := (if snd !_678__brake then 1. else 0.)));
      _self_1149._init1087 <- (&) !_1085 (not _cl672);
      (if _cl672 then _self_1149._pre1086 <- !_693__speed);
      (!_687__onn,
       !_688__off,
       !_689__set,
       !_690__resume,
       !_691__quickAccel,
       !_692__quickDecel, !_693__speed, !_694__accel, !_695__brake)

let plot
    _cl757
    _762__lx
    _763__ly (_764__bx, _765__by) (_766__x, _767__y) _1073 _self_1157 =
      let _1088 = ref () in
      (if _cl757 then
        _1088 :=
          Graphics.plot
            ((+) _764__bx ((mod) _766__x _762__lx))
            ((+) _765__by ((mod) _767__y _763__ly)));
      !_1088

let main _cl953 _cl862 () _1074 _self_1161 =
      let _self_1161 = match !_self_1161 with
                         | `St_1170(_self_1161) -> _self_1161
                         | _ ->
                             (let _1169 = {_1167 = ref `Snil_;
                                           _1166 = ref `Snil_;
                                           _1165 = ref `Snil_;
                                           _1164 = ref `Snil_;
                                           _1163 = ref `Snil_;
                                           _1162 = ref `Snil_;
                                           _init1093 = true;
                                           _pre1092 = 0; _pre1091 = 0} in
                              _self_1161 := `St_1170(_1169); _1169)
                          in
      let _968__nat = ref 0 in
      let _cl1104__ = ref false in
      let _cl1103__ = ref false in
      let _cl1102__ = ref false in
      let _1101 = ref () in
      let _1100 = ref (0., 0.) in
      let _cl1099__ = ref false in
      let _1098 = ref (false, false, false, false, false, false, 0., 0., 0.) in
      let _cl1097__ = ref false in
      let _956__key = ref (Obj.magic ()) in
      let _1090 = ref false in
      let _1089 = ref () in
      let _cl1105__ = ref false in
      (if _cl953 then
        (_1090 := (or) _1074 _self_1161._init1093;
         _956__key := (if !_1090 then Data.None else Data.keyboard ());
         _cl1097__ := true;
         _1098 := interface !_cl1097__ !_956__key !_1090 _self_1161._1162));
      (let (_957__onn,
            _958__off,
            _959__set,
            _960__resume,
            _961__quickAccel,
            _962__quickDecel, _963__speed, _964__accel, _965__brake) = 
       !_1098 in
       (if _cl953 then
         (_cl1099__ := true;
          _1100 :=
            cruiseControl
              !_cl1099__
              (_957__onn,
               _958__off,
               _960__resume,
               _963__speed,
               _959__set,
               _961__quickAccel, _962__quickDecel, _964__accel, _965__brake)
              !_1090 _self_1161._1163));
       (let (_966__cruiseSpeed, _967__throttleCmd) = !_1100 in
        (if _cl953 then _1101 := print_string "cruiseSpeed = ");
        (let _ = !_1101 in
         (if _cl953 then
           (_968__nat :=
              (if !_1090 then 0 else
                (if (=) _self_1161._pre1091 300 then 0 else
                  (+) _self_1161._pre1092 1));
            _cl1102__ := true;
            (let _ = plot
                       !_cl1102__
                       300
                       100
                       (0, 0)
                       (!_968__nat, int_of_float _963__speed)
                       !_1090 _self_1161._1164 in
             _cl1103__ := true;
             (let _ = plot
                        !_cl1103__
                        300
                        100
                        (0, 100)
                        (!_968__nat, int_of_float _964__accel)
                        !_1090 _self_1161._1165 in
              _cl1104__ := true;
              (let _ = plot
                         !_cl1104__
                         300
                         100
                         (0, 200)
                         (!_968__nat, int_of_float _966__cruiseSpeed)
                         !_1090 _self_1161._1166 in
               _cl1105__ := true;
               _1089 :=
                 (plot
                    !_cl1105__
                    300
                    100
                    (0, 300)
                    (!_968__nat, int_of_float _967__throttleCmd)
                    !_1090 _self_1161._1167;
                  (print_string " ";
                   (print_string "throttleCmd = ";
                    (print_float _967__throttleCmd; print_newline ())))))))));
         _self_1161._init1093 <- (&) !_1090 (not _cl953);
         (if _cl953 then
           (_self_1161._pre1092 <- !_968__nat;
            _self_1161._pre1091 <- !_968__nat));
         !_1089)))