(* simulation file *)
open Pendulum
let step, reset =
   let _m515 = ref `Snil_ in
   let step = fun _x514 -> manual true true _x514 false _m515 in
   let reset = fun () -> _m515 := `Snil_ in
   step, reset
let main _ = step ();;
(* simulation loop: sampled on 100 Hz *)
(* compiles with -custom unix.cma    *)
let periodic() =
   let _x = Unix.setitimer Unix.ITIMER_REAL
     {Unix.it_interval = 0.010000 ; Unix.it_value = 1.0 }
   in Sys.set_signal Sys.sigalrm (Sys.Signal_handle main);
   while true do Unix.sleep 1 done;;

 periodic();exit(0)
